#!/bin/sh
#
#  icefb.sh - written 07.20.2013
#  Creates a brows-able menu of directory contents in your icewm menu
#  Add to the menu with:
#  menuprogreload <dirname> <icon> icefb.sh <dirname>
#
#  Copyright 2013 Nathan Fisher <nfisher.sr@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#


#####################################################
# User configuration section

# What file manager are we using...
# filemanager="nautilus"
filemanager="thunar"
# filemanager="pcmanfm"
# filemanager="rox"

# Terminal program
# TERM="gnome-terminal"
TERM=xfce4-terminal
# TERM=evilvte
# TERM=rxvt
# TERM=xterm

# End config
####################################################


DIR="$1"
[ "$DIR" = "" ] && DIR=/
self=$(realpath $0)

cat << EOF
prog "$DIR filemanager" folder-open $filemanager "$DIR"
prog "$DIR terminal" utilities-terminal $TERM --working-directory="$DIR"
menu hidden folder {
EOF

find "$DIR" -maxdepth 1 -mindepth 1 -type d -name '.*'  | sort | while read SUBDIR
do
 MENUPROG="$(basename "$SUBDIR")"
 echo "menuprogreload \"$MENUPROG\" folder 0 $self \"$SUBDIR\""
done

find "$DIR" -maxdepth 1 -mindepth 1 -type f -name '.*'  | sort | while read FILE
do
 NAME="$(basename "$FILE")"
 echo "prog \"$NAME\" text-x-preview xdg-open \"$FILE\""
done

cat << EOF
}
separator
EOF

find "$DIR" -maxdepth 1 -mindepth 1 -type d ! -name '.*'  | sort | while read SUBDIR
do
 MENUPROG="$(basename "$SUBDIR")"
 echo "menuprogreload \"$MENUPROG\" folder 0 $self \"$SUBDIR\""
done

find "$DIR" -maxdepth 1 -mindepth 1 -type f ! -name '.*'  | sort | while read FILE
do
 NAME="$(basename "$FILE")"
 echo "prog \"$NAME\" text-x-preview xdg-open \"$FILE\""
done
